/**
 * tiles class
 */
function UGLightbox(){

	var t = this, g_objThis = jQuery(this);
	var g_gallery = new UniteGalleryMain(), g_objGallery, g_objWrapper;
	var g_objSlider = new UGSlider(), g_objOverlay, g_objArrowLeft, g_objArrowRight, g_objButtonClose;
	var g_functions = new UGFunctions(), g_objTextPanel = new UGTextPanel(), g_objNumbers;
	var g_objTopPanel;
	
	var g_options = {
			lightbox_textpanel_width: 550,
			lightbox_hide_arrows_onvideoplay: true
	};
	
	this.events = {
	};
	
	var g_temp = {
			topPanelHeight: 44,
			isOpened: false
	};
	
	var g_defaults = {
			slider_controls_always_on: true,
			slider_enable_bullets: false,
			slider_enable_arrows: false,
			slider_enable_progress_indicator: false,
			slider_enable_play_button: false,
			slider_enable_fullscreen_button: false,
			slider_enable_zoom_panel: false,
			slider_enable_text_panel: false,
			slider_scale_mode_media: "down",
			slider_scale_mode: "down",
			slider_loader_type: 3,
			slider_loader_color: "black",
			
			slider_image_padding_top: g_temp.topPanelHeight,
			slider_image_padding_bottom: 10,
			
			slider_video_padding_top: g_temp.topPanelHeight,
			slider_video_padding_bottom: 0,
			
			lightbox_textpanel_padding_top: 0,
			lightbox_textpanel_padding_bottom: 13,
			lightbox_textpanel_enable_title: true,
			lightbox_textpanel_enable_description: false,
			
			lightbox_textpanel_enable_bg:false,
			
			video_enable_closebutton: false,
			video_youtube_showinfo: false
	};
	
	function __________GENERAL_________(){};
	
	
	/**
	 * init the gallery
	 */
	function initLightbox(gallery, customOptions){
		
		g_gallery = gallery;
		g_objGallery = jQuery(gallery);
		
		var sliderOptions = g_defaults;
			
		g_options = jQuery.extend(g_options, g_defaults);
		g_options = jQuery.extend(g_options, customOptions);
		
		g_gallery.initSlider(sliderOptions);
		g_objects = gallery.getObjects();
		g_objSlider = g_objects.g_objSlider;
		
		g_objTextPanel.init(g_gallery, g_options, "lightbox");
	}
	
	
	/**
	 * put the lightbox html
	 */
	function putLightboxHtml(){
		
		var html = "";
		
		html += "<div class='ug-gallery-wrapper ug-lightbox'>";
		html += "<div class='ug-lightbox-overlay'></div>";
		
		html += "<div class='ug-lightbox-top-panel'>";
				
		html += 	"<div class='ug-lightbox-button-close'></div>";
		html += 	"<div class='ug-lightbox-numbers'></div>";
		
		html += "</div>";	//top panel
		
		html += "<div class='ug-lightbox-arrow-left'></div>";		
		html += "<div class='ug-lightbox-arrow-right'></div>";
		
		html += "</div>";
		
		g_objWrapper = jQuery(html);
		
		jQuery("body").append(g_objWrapper);
		
		g_objSlider.setHtml(g_objWrapper);
		
		g_objOverlay = g_objWrapper.children(".ug-lightbox-overlay");
		g_objTopPanel = g_objWrapper.children(".ug-lightbox-top-panel");
		
		g_objButtonClose = g_objTopPanel.children(".ug-lightbox-button-close");
		g_objNumbers = g_objTopPanel.children(".ug-lightbox-numbers");
		
		g_objArrowLeft = g_objWrapper.children(".ug-lightbox-arrow-left");
		g_objArrowRight = g_objWrapper.children(".ug-lightbox-arrow-right");
		
		g_objTextPanel.appendHTML(g_objTopPanel);
	}
	
	
	/**
	 * on everlay click
	 */
	function onOverlayClick(){
		
		t.close();
	}
	
	/**
	 * on item change
	 */
	function onItemChange(data, currentItem){
		
		g_objTextPanel.setTextPlain(currentItem.title, currentItem.description);
		
		//fill numbers text
		var numItems = g_gallery.getNumItems();
		var numCurrentItem = currentItem.index + 1;
		g_objNumbers.html(numCurrentItem + " / " + numItems);
	}
	
	/**
	 * on slider click
	 */
	function onSliderClick(data, event){
		
		var isInside = g_objSlider.isMouseInsideSlideImage(event);
		if(isInside == false)
			t.close();
		
	}
	
	/**
	 * on lightbox resize
	 */
	function onResize(){
		
		positionElements();
			
	}
	
	
	/**
	 * on start play - hide the side buttons
	 */
	function onPlayVideo(){
		
		if(g_objArrowLeft && g_options.lightbox_hide_arrows_onvideoplay == true){
			g_objArrowLeft.hide();			
			g_objArrowRight.hide();			
		}
		
	}
	
	/**
	 * on stop video - show the side buttons
	 */
	function onStopVideo(){
		
		if(g_objArrowLeft && g_options.lightbox_hide_arrows_onvideoplay == true){
			g_objArrowLeft.show();
			g_objArrowRight.show();			
		}
				
	}
	
	
	/**
	 * init events
	 */
	function initEvents(){
		
		g_objOverlay.on("touchend click", onOverlayClick);
		
		g_functions.addClassOnHover(g_objArrowRight, "ug-arrow-hover");
		g_functions.addClassOnHover(g_objArrowLeft, "ug-arrow-hover");
		
		g_functions.addClassOnHover(g_objButtonClose);
		
		g_gallery.setNextButton(g_objArrowRight);
		g_gallery.setPrevButton(g_objArrowLeft);
		
		g_functions.setButtonMobileReady(g_objButtonClose);
		
		g_objButtonClose.on("click touchend",function(){
			t.close();
		});
		
		g_objGallery.on(g_gallery.events.ITEM_CHANGE, onItemChange);
		
		//on slider click event
		jQuery(g_objSlider).on(g_objSlider.events.CLICK, onSliderClick);
		
		//on slider video 
		var objVideo = g_objSlider.getVideoObject();
				
		jQuery(objVideo).on(objVideo.events.PLAY_START, onPlayVideo);
		jQuery(objVideo).on(objVideo.events.PLAY_STOP, onStopVideo);
		
		//on resize
		 jQuery(window).resize(function(){
			 
			 if(g_temp.isOpened == false)
				 return(true);
			 
			 g_functions.whenContiniousEventOver("lightbox_resize", onResize, 100);
		 });
		
		 
	}
	
	
	/**
	 * position the elements
	 */
	function positionElements(){
		
		var size = g_functions.getElementSize(g_objWrapper);
		
		//position top panel:
		g_functions.setElementSizeAndPosition(g_objTopPanel, 0, 0, size.width, g_temp.topPanelHeight);
		
				
		//position arrows
		if(g_objArrowLeft){
			
			if(g_options.lightbox_hide_arrows_onvideoplay == true){
				g_objArrowLeft.show();			
				g_objArrowRight.show();				
			}
			
			g_functions.placeElement(g_objArrowLeft, 0, "middle");
			g_functions.placeElement(g_objArrowRight, "right", "middle");
			
			g_functions.placeElement(g_objButtonClose, "right", "top", 2, 2);
		}		
		
		//place text panel
		var textWidth = g_options.lightbox_textpanel_width;
		var textMinPadding = 20;
		if(textWidth > size.width)
			textWidth = size.width - textMinPadding;
		
		var objOptions = {};
		objOptions.textpanel_padding_left = Math.floor((size.width - textWidth) / 2);
		objOptions.textpanel_padding_right = objOptions.textpanel_padding_left;
		g_objTextPanel.setOptions(objOptions)
		
		g_objTextPanel.refresh(true);
		
		//position slider
		var panelSize = g_objTextPanel.getSize();
		
		var sliderWidth = size.width;
		var sliderHeight = size.height;	
		var sliderTop = 0;
		var sliderLeft = 0;
		
		g_objSlider.setSize(sliderWidth, sliderHeight);
		g_objSlider.setPosition(sliderLeft, sliderTop);
		
		//printItems();
	}
	
	function printItems(){
		var items = g_gallery.getArrItems();
				
		for(index in items){
			var item = items[index];
			trace(item);
		}
		
	}
	
	
	/**
	 * open the lightbox with some item index
	 */
	this.open = function(index){
				
		var objItem = g_gallery.getItem(index);
		g_objSlider.setItem(objItem, "fade");
		
		g_objTextPanel.setTextPlain(objItem.title, objItem.description);
		
		g_objWrapper.show();
		positionElements();
		
		g_objSlider.startSlideAction();
		
		g_temp.isOpened = true;
	}
	
	
	/**
	 * close the lightbox
	 */
	this.close = function(){
		
		g_objSlider.stopSlideAction();
		g_objWrapper.hide();
		
		g_temp.isOpened = false;
	}
	
	
	/**
	 * external init function
	 */
	this.init = function(gallery, customOptions){
		
		initLightbox(gallery, customOptions);
	}
	
	
	/**
	 * external put html function
	 */
	this.putHtml = function(){
		
		putLightboxHtml();
		
	}
	
	/**
	 * run lightbox elements
	 */
	this.run = function(){
		
		g_objSlider.run();
		initEvents();
	}
	
	
	
}


